Index: sansmodels/src/sans/models/c_extensions/binaryHS.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/binaryHS.c	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
+++ sansmodels/src/sans/models/c_extensions/binaryHS.c	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -0,0 +1,44 @@
+/**
+ * Scattering model for a sphere
+ * @author: Gervaise B alina / UTK
+ */
+
+#include "binaryHS.h"
+#include "libSphere.h"
+#include <math.h>
+
+
+/**
+ * Function to evaluate 1D scattering function
+ * @param pars: parameters of the binary hard sphere
+ * @param q: q-value
+ * @return: function value
+ */
+double binaryHS_analytical_1D(BinaryHSParameters *pars, double q) {
+	double dp[8];
+	
+	dp[0] = pars->l_radius;
+	dp[1] = pars->s_radius;
+	dp[2] = pars->vol_frac_ls;
+	dp[3] = pars->vol_frac_ss;
+	dp[4] = pars->ls_sld;
+	dp[5] = pars->ss_sld;
+	dp[6] = pars->solvent_sld;
+	dp[7] = pars->background;
+	
+	return BinaryHS(dp, q);
+}
+    
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the binary hard sphere
+ * @param q: q-value
+ * @return: function value
+ */
+double binaryHS_analytical_2D(BinaryHSParameters *pars, double q, double phi) {
+	return binaryHS_analytical_1D(pars,q);
+}
+
+double binaryHS_analytical_2DXY(BinaryHSParameters *pars, double qx, double qy){
+	return binaryHS_analytical_1D(pars,sqrt(qx*qx+qy*qy));	
+}
Index: sansmodels/src/sans/models/c_extensions/binaryHs.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/binaryHs.h	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
+++ sansmodels/src/sans/models/c_extensions/binaryHs.h	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -0,0 +1,69 @@
+#if !defined(binaryHS_h)
+#define binaryHS_h
+
+/**
+ * Structure definition for binary hard sphere parameters
+
+	[PYTHONCLASS] = BinaryHSModel
+	[DISP_PARAMS] = l_radius,s_radius
+	[DESCRIPTION] =<text>
+						Model parameters:
+						
+						l_radius : large radius of the binary hard sphere
+						s_radius : small radius of the binary hard sphere
+						vol_frac_ls : volume fraction of large spheres 
+						vol_frac_ss : volume fraction of small spheres
+						ls_sld: large sphere  scattering length density
+						ss_sld: small sphere scattering length density
+						solvent_sld: solvent scattering length density
+						background: incoherent background
+               </text>
+	[FIXED]= l_radius.width;s_radius.width
+	[ORIENTATION_PARAMS]= <text> </text>
+ */
+typedef struct {
+    
+	///	large radius of the binary hard sphere [A]
+    //  [DEFAULT]=l_radius= 160.0 [A]
+    double l_radius;
+
+    ///	small radius of the binary hard sphere [A]
+    //  [DEFAULT]=s_radius= 25.0 [A]
+    double s_radius;
+
+	///	volume fraction of large spheres 
+    //  [DEFAULT]=vol_frac_ls= 0.2 
+    double vol_frac_ls;
+
+	///	volume fraction of small spheres 
+    //  [DEFAULT]=vol_frac_ss= 0.2 
+    double vol_frac_ss;
+
+	///	large sphere scattering length density [1/Å²]
+    //  [DEFAULT]=ls_sld= 3.5e-6 [1/A²]
+    double ls_sld;
+
+	///	lsmall sphere scattering length density [1/Å²]
+    //  [DEFAULT]=ss_sld= 5e-7 [1/A²]
+    double ss_sld;
+
+    ///	solvent scattering length density [1/Å²]
+    //  [DEFAULT]=solvent_sld= 6.36e-6 [1/A²]
+    double solvent_sld;
+
+	/// Incoherent Background [1/cm]
+	//  [DEFAULT]=background=0.001 [1/cm]
+	double background;
+
+} BinaryHSParameters;
+
+
+
+/// 1D scattering function
+double binaryHS_analytical_1D(BinaryHSParameters *pars, double q);
+
+/// 2D scattering function
+double binaryHS_analytical_2D(BinaryHSParameters *pars, double q, double phi);
+double binaryHS_analytical_2DXY(BinaryHSParameters *pars, double qx, double qy);
+
+#endif
Index: sansmodels/src/sans/models/c_extensions/c_models.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/c_models.c	(revision 793c988b04291cd397c5f548ab1ff0f30df072cb)
+++ sansmodels/src/sans/models/c_extensions/c_models.c	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -52,4 +52,7 @@
 	addCLorentzian(m);
 	addCHollowCylinderModel(m);
+	addCMultiShellModel(m);
+	addCVesicleModel(m);
+	addCBinaryHSModel(m);
 
 }
Index: sansmodels/src/sans/models/c_extensions/multishell.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/multishell.c	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
+++ sansmodels/src/sans/models/c_extensions/multishell.c	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -0,0 +1,44 @@
+/**
+ * Scattering model for a sphere
+ * @author: Gervaise B alina / UTK
+ */
+
+#include "multishell.h"
+#include "libSphere.h"
+#include <math.h>
+
+
+/**
+ * Function to evaluate 1D scattering function
+ * @param pars: parameters of the multishell
+ * @param q: q-value
+ * @return: function value
+ */
+double multishell_analytical_1D(MultiShellParameters *pars, double q) {
+	double dp[8];
+	
+	dp[0] = pars->scale;
+	dp[1] = pars->core_radius;
+	dp[2] = pars->s_thickness;
+	dp[3] = pars->w_thickness;
+	dp[4] = pars->core_sld;
+	dp[5] = pars->shell_sld;
+	dp[6] = pars->n_pairs;
+	dp[7] = pars->background;
+	
+	return MultiShell(dp, q);
+}
+    
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the multishell
+ * @param q: q-value
+ * @return: function value
+ */
+double multishell_analytical_2D(MultiShellParameters *pars, double q, double phi) {
+	return multishell_analytical_1D(pars,q);
+}
+
+double multishell_analytical_2DXY(MultiShellParameters *pars, double qx, double qy){
+	return multishell_analytical_1D(pars,sqrt(qx*qx+qy*qy));	
+}
Index: sansmodels/src/sans/models/c_extensions/multishell.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/multishell.h	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
+++ sansmodels/src/sans/models/c_extensions/multishell.h	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -0,0 +1,67 @@
+#if !defined(multishell_h)
+#define multishell_h
+
+/**
+ * Structure definition for sphere parameters
+
+	[PYTHONCLASS] = MultiShellModel
+	[DISP_PARAMS] = core_radius
+	[DESCRIPTION] =<text>
+						Model parameters:
+						scale : scale factor
+						core_radius : Core radius of the multishell 
+						s_thickness: shell thickness
+						w_thickness: water thickness
+						core_sld: core scattering length density
+						shell_sld: shell scattering length density
+						n_pairs:number of pairs of water/shell
+						background: incoherent background
+               </text>
+	[FIXED]=  core_radius.width
+	[ORIENTATION_PARAMS]= <text> </text>
+ */
+typedef struct {
+    /// Scale factor
+    //  [DEFAULT]=scale= 1.0
+    double scale;
+
+    ///	Core radius of the multishell [A]
+    //  [DEFAULT]=core_radius=60.0 [A]
+    double core_radius;
+
+	///	shell thickness [Å]
+    //  [DEFAULT]=s_thickness= 10.0 [A]
+    double s_thickness;
+
+    ///	water thickness [Å]
+    //  [DEFAULT]=w_thickness= 10.0 [A]
+    double w_thickness;
+
+	///	core scattering length density [1/Å²]
+    //  [DEFAULT]=core_sld= 6.4e-6 [1/A²]
+    double core_sld;
+
+    ///	shell scattering length density [1/Å²]
+    //  [DEFAULT]=shell_sld= 4.0e-7 [1/A²]
+    double shell_sld;
+
+	///	number of pairs of water and shell
+    //  [DEFAULT]=n_pairs= 2
+    double n_pairs;
+
+	/// Incoherent Background [1/cm]
+	//  [DEFAULT]=background=0 [1/cm]
+	double background;
+
+} MultiShellParameters;
+
+
+
+/// 1D scattering function
+double multishell_analytical_1D(MultiShellParameters *pars, double q);
+
+/// 2D scattering function
+double multishell_analytical_2D(MultiShellParameters *pars, double q, double phi);
+double multishell_analytical_2DXY(MultiShellParameters *pars, double qx, double qy);
+
+#endif
Index: sansmodels/src/sans/models/c_extensions/vesicle.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/vesicle.c	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
+++ sansmodels/src/sans/models/c_extensions/vesicle.c	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -0,0 +1,43 @@
+/**
+ * Scattering model for a sphere
+ * @author: Gervaise B alina / UTK
+ */
+
+#include "vesicle.h"
+#include "libSphere.h"
+#include <math.h>
+
+
+/**
+ * Function to evaluate 1D scattering function
+ * @param pars: parameters of the vesicle
+ * @param q: q-value
+ * @return: function value
+ */
+double vesicle_analytical_1D(VesicleParameters *pars, double q) {
+	double dp[6];
+	
+	dp[0] = pars->scale;
+	dp[1] = pars->core_radius;
+	dp[2] = pars->thickness;
+	dp[3] = pars->core_sld;
+	dp[4] = pars->shell_sld;
+	dp[5] = pars->background;
+
+	
+	return VesicleForm(dp, q);
+}
+    
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the vesicle
+ * @param q: q-value
+ * @return: function value
+ */
+double vesicle_analytical_2D(VesicleParameters *pars, double q, double phi) {
+	return vesicle_analytical_1D(pars,q);
+}
+
+double vesicle_analytical_2DXY(VesicleParameters *pars, double qx, double qy){
+	return vesicle_analytical_1D(pars,sqrt(qx*qx+qy*qy));	
+}
Index: sansmodels/src/sans/models/c_extensions/vesicle.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/vesicle.h	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
+++ sansmodels/src/sans/models/c_extensions/vesicle.h	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -0,0 +1,57 @@
+#if !defined(vesicle_h)
+#define vesicle_h
+
+/**
+ * Structure definition for vesicle parameters
+
+	[PYTHONCLASS] = VesicleModel
+	[DISP_PARAMS] = core_radius
+	[DESCRIPTION] =<text>
+						Model parameters:
+						scale : scale factor
+						core_radius : Core radius of the vesicle
+						thickness: shell thickness
+						core_sld: core scattering length density
+						shell_sld: shell scattering length density
+						background: incoherent background
+               </text>
+	[FIXED]=  core_radius.width
+	[ORIENTATION_PARAMS]= <text> </text>
+ */
+typedef struct {
+    /// Scale factor
+    //  [DEFAULT]=scale= 1.0
+    double scale;
+
+    ///	Core radius of the vesicle [A]
+    //  [DEFAULT]=core_radius= 100.0 [A]
+    double core_radius;
+
+	///	shell thickness [Å]
+    //  [DEFAULT]=thickness= 30.0 [A]
+    double thickness;
+
+	///	core scattering length density [1/Å²]
+    //  [DEFAULT]=core_sld= 6.36e-6 [1/A²]
+    double core_sld;
+
+    ///	shell scattering length density [1/Å²]
+    //  [DEFAULT]=shell_sld= 5.0e-7 [1/A²]
+    double shell_sld;
+
+	/// Incoherent Background [1/cm]
+	//  [DEFAULT]=background=0 [1/cm]
+	double background;
+
+} VesicleParameters;
+
+
+
+/// 1D scattering function
+double vesicle_analytical_1D(VesicleParameters *pars, double q);
+
+/// 2D scattering function
+double vesicle_analytical_2D(VesicleParameters *pars, double q, double phi);
+double vesicle_analytical_2DXY(VesicleParameters *pars, double qx, double qy);
+
+#endif
Index: sansmodels/src/sans/models/c_models/CBinaryHSModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CBinaryHSModel.cpp	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
+++ sansmodels/src/sans/models/c_models/CBinaryHSModel.cpp	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -0,0 +1,384 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/** CBinaryHSModel
+ *
+ * C extension 
+ *
+ * WARNING: THIS FILE WAS GENERATED BY WRAPPERGENERATOR.PY
+ *          DO NOT MODIFY THIS FILE, MODIFY binaryHS.h
+ *          AND RE-RUN THE GENERATOR SCRIPT
+ *
+ */
+ 
+extern "C" {
+#include <Python.h>
+#include "structmember.h"
+#include <stdio.h>
+#include <stdlib.h>
+#include <math.h>
+#include <time.h>
+#include "binaryHS.h"
+}
+
+#include "models.hh"
+#include "dispersion_visitor.hh"
+
+/// Error object for raised exceptions
+static PyObject * CBinaryHSModelError = NULL;
+
+
+// Class definition
+typedef struct {
+    PyObject_HEAD
+    /// Parameters
+    PyObject * params;
+    /// Dispersion parameters
+    PyObject * dispersion;
+    /// Underlying model object
+    BinaryHSModel * model;
+    /// Log for unit testing
+    PyObject * log;
+} CBinaryHSModel;
+
+
+static void
+CBinaryHSModel_dealloc(CBinaryHSModel* self)
+{
+    self->ob_type->tp_free((PyObject*)self);
+    
+
+}
+
+static PyObject *
+CBinaryHSModel_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
+{
+    CBinaryHSModel *self;
+    
+    self = (CBinaryHSModel *)type->tp_alloc(type, 0);
+   
+    return (PyObject *)self;
+}
+
+static int
+CBinaryHSModel_init(CBinaryHSModel *self, PyObject *args, PyObject *kwds)
+{
+    if (self != NULL) {
+    	
+    	// Create parameters
+        self->params = PyDict_New();
+        self->dispersion = PyDict_New();
+        self->model = new BinaryHSModel();
+        
+        // Initialize parameter dictionary
+        PyDict_SetItemString(self->params,"vol_frac_ls",Py_BuildValue("d",0.200000));
+        PyDict_SetItemString(self->params,"background",Py_BuildValue("d",0.001000));
+        PyDict_SetItemString(self->params,"vol_frac_ss",Py_BuildValue("d",0.200000));
+        PyDict_SetItemString(self->params,"solvent_sld",Py_BuildValue("d",0.000006));
+        PyDict_SetItemString(self->params,"ls_sld",Py_BuildValue("d",0.000003));
+        PyDict_SetItemString(self->params,"ss_sld",Py_BuildValue("d",0.000000));
+        PyDict_SetItemString(self->params,"s_radius",Py_BuildValue("d",25.000000));
+        PyDict_SetItemString(self->params,"l_radius",Py_BuildValue("d",160.000000));
+        // Initialize dispersion / averaging parameter dict
+        DispersionVisitor* visitor = new DispersionVisitor();
+        PyObject * disp_dict;
+        disp_dict = PyDict_New();
+        self->model->l_radius.dispersion->accept_as_source(visitor, self->model->l_radius.dispersion, disp_dict);
+        PyDict_SetItemString(self->dispersion, "l_radius", disp_dict);
+        disp_dict = PyDict_New();
+        self->model->s_radius.dispersion->accept_as_source(visitor, self->model->s_radius.dispersion, disp_dict);
+        PyDict_SetItemString(self->dispersion, "s_radius", disp_dict);
+
+
+         
+        // Create empty log
+        self->log = PyDict_New();
+        
+        
+
+    }
+    return 0;
+}
+
+static PyMemberDef CBinaryHSModel_members[] = {
+    {"params", T_OBJECT, offsetof(CBinaryHSModel, params), 0,
+     "Parameters"},
+	{"dispersion", T_OBJECT, offsetof(CBinaryHSModel, dispersion), 0,
+	  "Dispersion parameters"},     
+    {"log", T_OBJECT, offsetof(CBinaryHSModel, log), 0,
+     "Log"},
+    {NULL}  /* Sentinel */
+};
+
+/** Read double from PyObject
+    @param p PyObject
+    @return double
+*/
+double CBinaryHSModel_readDouble(PyObject *p) {
+    if (PyFloat_Check(p)==1) {
+        return (double)(((PyFloatObject *)(p))->ob_fval);
+    } else if (PyInt_Check(p)==1) {
+        return (double)(((PyIntObject *)(p))->ob_ival);
+    } else if (PyLong_Check(p)==1) {
+        return (double)PyLong_AsLong(p);
+    } else {
+        return 0.0;
+    }
+}
+
+
+/**
+ * Function to call to evaluate model
+ * @param args: input q or [q,phi]
+ * @return: function value
+ */
+static PyObject * run(CBinaryHSModel *self, PyObject *args) {
+	double q_value, phi_value;
+	PyObject* pars;
+	int npars;
+	
+	// Get parameters
+	
+	    // Reader parameter dictionary
+    self->model->vol_frac_ls = PyFloat_AsDouble( PyDict_GetItemString(self->params, "vol_frac_ls") );
+    self->model->background = PyFloat_AsDouble( PyDict_GetItemString(self->params, "background") );
+    self->model->vol_frac_ss = PyFloat_AsDouble( PyDict_GetItemString(self->params, "vol_frac_ss") );
+    self->model->solvent_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "solvent_sld") );
+    self->model->ls_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "ls_sld") );
+    self->model->ss_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "ss_sld") );
+    self->model->s_radius = PyFloat_AsDouble( PyDict_GetItemString(self->params, "s_radius") );
+    self->model->l_radius = PyFloat_AsDouble( PyDict_GetItemString(self->params, "l_radius") );
+    // Read in dispersion parameters
+    PyObject* disp_dict;
+    DispersionVisitor* visitor = new DispersionVisitor();
+    disp_dict = PyDict_GetItemString(self->dispersion, "l_radius");
+    self->model->l_radius.dispersion->accept_as_destination(visitor, self->model->l_radius.dispersion, disp_dict);
+    disp_dict = PyDict_GetItemString(self->dispersion, "s_radius");
+    self->model->s_radius.dispersion->accept_as_destination(visitor, self->model->s_radius.dispersion, disp_dict);
+
+	
+	// Get input and determine whether we have to supply a 1D or 2D return value.
+	if ( !PyArg_ParseTuple(args,"O",&pars) ) {
+	    PyErr_SetString(CBinaryHSModelError, 
+	    	"CBinaryHSModel.run expects a q value.");
+		return NULL;
+	}
+	  
+	// Check params
+	if( PyList_Check(pars)==1) {
+		
+		// Length of list should be 2 for I(q,phi)
+	    npars = PyList_GET_SIZE(pars); 
+	    if(npars!=2) {
+	    	PyErr_SetString(CBinaryHSModelError, 
+	    		"CBinaryHSModel.run expects a double or a list of dimension 2.");
+	    	return NULL;
+	    }
+	    // We have a vector q, get the q and phi values at which
+	    // to evaluate I(q,phi)
+	    q_value = CBinaryHSModel_readDouble(PyList_GET_ITEM(pars,0));
+	    phi_value = CBinaryHSModel_readDouble(PyList_GET_ITEM(pars,1));
+	    // Skip zero
+	    if (q_value==0) {
+	    	return Py_BuildValue("d",0.0);
+	    }
+		return Py_BuildValue("d",(*(self->model)).evaluate_rphi(q_value,phi_value));
+
+	} else {
+
+		// We have a scalar q, we will evaluate I(q)
+		q_value = CBinaryHSModel_readDouble(pars);		
+		
+		return Py_BuildValue("d",(*(self->model))(q_value));
+	}	
+}
+
+/**
+ * Function to call to evaluate model in cartesian coordinates
+ * @param args: input q or [qx, qy]]
+ * @return: function value
+ */
+static PyObject * runXY(CBinaryHSModel *self, PyObject *args) {
+	double qx_value, qy_value;
+	PyObject* pars;
+	int npars;
+	
+	// Get parameters
+	
+	    // Reader parameter dictionary
+    self->model->vol_frac_ls = PyFloat_AsDouble( PyDict_GetItemString(self->params, "vol_frac_ls") );
+    self->model->background = PyFloat_AsDouble( PyDict_GetItemString(self->params, "background") );
+    self->model->vol_frac_ss = PyFloat_AsDouble( PyDict_GetItemString(self->params, "vol_frac_ss") );
+    self->model->solvent_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "solvent_sld") );
+    self->model->ls_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "ls_sld") );
+    self->model->ss_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "ss_sld") );
+    self->model->s_radius = PyFloat_AsDouble( PyDict_GetItemString(self->params, "s_radius") );
+    self->model->l_radius = PyFloat_AsDouble( PyDict_GetItemString(self->params, "l_radius") );
+    // Read in dispersion parameters
+    PyObject* disp_dict;
+    DispersionVisitor* visitor = new DispersionVisitor();
+    disp_dict = PyDict_GetItemString(self->dispersion, "l_radius");
+    self->model->l_radius.dispersion->accept_as_destination(visitor, self->model->l_radius.dispersion, disp_dict);
+    disp_dict = PyDict_GetItemString(self->dispersion, "s_radius");
+    self->model->s_radius.dispersion->accept_as_destination(visitor, self->model->s_radius.dispersion, disp_dict);
+
+	
+	// Get input and determine whether we have to supply a 1D or 2D return value.
+	if ( !PyArg_ParseTuple(args,"O",&pars) ) {
+	    PyErr_SetString(CBinaryHSModelError, 
+	    	"CBinaryHSModel.run expects a q value.");
+		return NULL;
+	}
+	  
+	// Check params
+	if( PyList_Check(pars)==1) {
+		
+		// Length of list should be 2 for I(qx, qy))
+	    npars = PyList_GET_SIZE(pars); 
+	    if(npars!=2) {
+	    	PyErr_SetString(CBinaryHSModelError, 
+	    		"CBinaryHSModel.run expects a double or a list of dimension 2.");
+	    	return NULL;
+	    }
+	    // We have a vector q, get the qx and qy values at which
+	    // to evaluate I(qx,qy)
+	    qx_value = CBinaryHSModel_readDouble(PyList_GET_ITEM(pars,0));
+	    qy_value = CBinaryHSModel_readDouble(PyList_GET_ITEM(pars,1));
+	    return Py_BuildValue("d",(*(self->model))(qx_value,qy_value));
+
+	} else {
+
+		// We have a scalar q, we will evaluate I(q)
+		qx_value = CBinaryHSModel_readDouble(pars);		
+		
+		return Py_BuildValue("d",(*(self->model))(qx_value));
+	}	
+}
+
+static PyObject * reset(CBinaryHSModel *self, PyObject *args) {
+    
+
+    return Py_BuildValue("d",0.0);
+}
+
+static PyObject * set_dispersion(CBinaryHSModel *self, PyObject *args) {
+	PyObject * disp;
+	const char * par_name;
+
+	if ( !PyArg_ParseTuple(args,"sO", &par_name, &disp) ) {
+	    PyErr_SetString(CBinaryHSModelError,
+	    	"CBinaryHSModel.set_dispersion expects a DispersionModel object.");
+		return NULL;
+	}
+	void *temp = PyCObject_AsVoidPtr(disp);
+	DispersionModel * dispersion = static_cast<DispersionModel *>(temp);
+
+
+	// Ugliness necessary to go from python to C
+	    // TODO: refactor this
+    if (!strcmp(par_name, "l_radius")) {
+        self->model->l_radius.dispersion = dispersion;
+    } else    if (!strcmp(par_name, "s_radius")) {
+        self->model->s_radius.dispersion = dispersion;
+    } else {
+	    PyErr_SetString(CBinaryHSModelError,
+	    	"CBinaryHSModel.set_dispersion expects a valid parameter name.");
+		return NULL;
+	}
+
+	DispersionVisitor* visitor = new DispersionVisitor();
+	PyObject * disp_dict = PyDict_New();
+	dispersion->accept_as_source(visitor, dispersion, disp_dict);
+	PyDict_SetItemString(self->dispersion, par_name, disp_dict);
+    return Py_BuildValue("i",1);
+}
+
+
+static PyMethodDef CBinaryHSModel_methods[] = {
+    {"run",      (PyCFunction)run     , METH_VARARGS,
+      "Evaluate the model at a given Q or Q, phi"},
+    {"runXY",      (PyCFunction)runXY     , METH_VARARGS,
+      "Evaluate the model at a given Q or Qx, Qy"},
+    {"reset",    (PyCFunction)reset   , METH_VARARGS,
+      "Reset pair correlation"},
+    {"set_dispersion",      (PyCFunction)set_dispersion     , METH_VARARGS,
+      "Set the dispersion model for a given parameter"},
+   {NULL}
+};
+
+static PyTypeObject CBinaryHSModelType = {
+    PyObject_HEAD_INIT(NULL)
+    0,                         /*ob_size*/
+    "CBinaryHSModel",             /*tp_name*/
+    sizeof(CBinaryHSModel),             /*tp_basicsize*/
+    0,                         /*tp_itemsize*/
+    (destructor)CBinaryHSModel_dealloc, /*tp_dealloc*/
+    0,                         /*tp_print*/
+    0,                         /*tp_getattr*/
+    0,                         /*tp_setattr*/
+    0,                         /*tp_compare*/
+    0,                         /*tp_repr*/
+    0,                         /*tp_as_number*/
+    0,                         /*tp_as_sequence*/
+    0,                         /*tp_as_mapping*/
+    0,                         /*tp_hash */
+    0,                         /*tp_call*/
+    0,                         /*tp_str*/
+    0,                         /*tp_getattro*/
+    0,                         /*tp_setattro*/
+    0,                         /*tp_as_buffer*/
+    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
+    "CBinaryHSModel objects",           /* tp_doc */
+    0,		               /* tp_traverse */
+    0,		               /* tp_clear */
+    0,		               /* tp_richcompare */
+    0,		               /* tp_weaklistoffset */
+    0,		               /* tp_iter */
+    0,		               /* tp_iternext */
+    CBinaryHSModel_methods,             /* tp_methods */
+    CBinaryHSModel_members,             /* tp_members */
+    0,                         /* tp_getset */
+    0,                         /* tp_base */
+    0,                         /* tp_dict */
+    0,                         /* tp_descr_get */
+    0,                         /* tp_descr_set */
+    0,                         /* tp_dictoffset */
+    (initproc)CBinaryHSModel_init,      /* tp_init */
+    0,                         /* tp_alloc */
+    CBinaryHSModel_new,                 /* tp_new */
+};
+
+
+static PyMethodDef module_methods[] = {
+    {NULL} 
+};
+
+/**
+ * Function used to add the model class to a module
+ * @param module: module to add the class to
+ */ 
+void addCBinaryHSModel(PyObject *module) {
+	PyObject *d;
+	
+    if (PyType_Ready(&CBinaryHSModelType) < 0)
+        return;
+
+    Py_INCREF(&CBinaryHSModelType);
+    PyModule_AddObject(module, "CBinaryHSModel", (PyObject *)&CBinaryHSModelType);
+    
+    d = PyModule_GetDict(module);
+    CBinaryHSModelError = PyErr_NewException("CBinaryHSModel.error", NULL, NULL);
+    PyDict_SetItemString(d, "CBinaryHSModelError", CBinaryHSModelError);
+}
+
Index: sansmodels/src/sans/models/c_models/CMultiShellModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CMultiShellModel.cpp	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
+++ sansmodels/src/sans/models/c_models/CMultiShellModel.cpp	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -0,0 +1,375 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/** CMultiShellModel
+ *
+ * C extension 
+ *
+ * WARNING: THIS FILE WAS GENERATED BY WRAPPERGENERATOR.PY
+ *          DO NOT MODIFY THIS FILE, MODIFY multishell.h
+ *          AND RE-RUN THE GENERATOR SCRIPT
+ *
+ */
+ 
+extern "C" {
+#include <Python.h>
+#include "structmember.h"
+#include <stdio.h>
+#include <stdlib.h>
+#include <math.h>
+#include <time.h>
+#include "multishell.h"
+}
+
+#include "models.hh"
+#include "dispersion_visitor.hh"
+
+/// Error object for raised exceptions
+static PyObject * CMultiShellModelError = NULL;
+
+
+// Class definition
+typedef struct {
+    PyObject_HEAD
+    /// Parameters
+    PyObject * params;
+    /// Dispersion parameters
+    PyObject * dispersion;
+    /// Underlying model object
+    MultiShellModel * model;
+    /// Log for unit testing
+    PyObject * log;
+} CMultiShellModel;
+
+
+static void
+CMultiShellModel_dealloc(CMultiShellModel* self)
+{
+    self->ob_type->tp_free((PyObject*)self);
+    
+
+}
+
+static PyObject *
+CMultiShellModel_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
+{
+    CMultiShellModel *self;
+    
+    self = (CMultiShellModel *)type->tp_alloc(type, 0);
+   
+    return (PyObject *)self;
+}
+
+static int
+CMultiShellModel_init(CMultiShellModel *self, PyObject *args, PyObject *kwds)
+{
+    if (self != NULL) {
+    	
+    	// Create parameters
+        self->params = PyDict_New();
+        self->dispersion = PyDict_New();
+        self->model = new MultiShellModel();
+        
+        // Initialize parameter dictionary
+        PyDict_SetItemString(self->params,"core_sld",Py_BuildValue("d",0.000006));
+        PyDict_SetItemString(self->params,"core_radius",Py_BuildValue("d",60.000000));
+        PyDict_SetItemString(self->params,"n_pairs",Py_BuildValue("d",2.000000));
+        PyDict_SetItemString(self->params,"w_thickness",Py_BuildValue("d",10.000000));
+        PyDict_SetItemString(self->params,"s_thickness",Py_BuildValue("d",10.000000));
+        PyDict_SetItemString(self->params,"scale",Py_BuildValue("d",1.000000));
+        PyDict_SetItemString(self->params,"background",Py_BuildValue("d",0.000000));
+        PyDict_SetItemString(self->params,"shell_sld",Py_BuildValue("d",0.000000));
+        // Initialize dispersion / averaging parameter dict
+        DispersionVisitor* visitor = new DispersionVisitor();
+        PyObject * disp_dict;
+        disp_dict = PyDict_New();
+        self->model->core_radius.dispersion->accept_as_source(visitor, self->model->core_radius.dispersion, disp_dict);
+        PyDict_SetItemString(self->dispersion, "core_radius", disp_dict);
+
+
+         
+        // Create empty log
+        self->log = PyDict_New();
+        
+        
+
+    }
+    return 0;
+}
+
+static PyMemberDef CMultiShellModel_members[] = {
+    {"params", T_OBJECT, offsetof(CMultiShellModel, params), 0,
+     "Parameters"},
+	{"dispersion", T_OBJECT, offsetof(CMultiShellModel, dispersion), 0,
+	  "Dispersion parameters"},     
+    {"log", T_OBJECT, offsetof(CMultiShellModel, log), 0,
+     "Log"},
+    {NULL}  /* Sentinel */
+};
+
+/** Read double from PyObject
+    @param p PyObject
+    @return double
+*/
+double CMultiShellModel_readDouble(PyObject *p) {
+    if (PyFloat_Check(p)==1) {
+        return (double)(((PyFloatObject *)(p))->ob_fval);
+    } else if (PyInt_Check(p)==1) {
+        return (double)(((PyIntObject *)(p))->ob_ival);
+    } else if (PyLong_Check(p)==1) {
+        return (double)PyLong_AsLong(p);
+    } else {
+        return 0.0;
+    }
+}
+
+
+/**
+ * Function to call to evaluate model
+ * @param args: input q or [q,phi]
+ * @return: function value
+ */
+static PyObject * run(CMultiShellModel *self, PyObject *args) {
+	double q_value, phi_value;
+	PyObject* pars;
+	int npars;
+	
+	// Get parameters
+	
+	    // Reader parameter dictionary
+    self->model->core_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "core_sld") );
+    self->model->core_radius = PyFloat_AsDouble( PyDict_GetItemString(self->params, "core_radius") );
+    self->model->n_pairs = PyFloat_AsDouble( PyDict_GetItemString(self->params, "n_pairs") );
+    self->model->w_thickness = PyFloat_AsDouble( PyDict_GetItemString(self->params, "w_thickness") );
+    self->model->s_thickness = PyFloat_AsDouble( PyDict_GetItemString(self->params, "s_thickness") );
+    self->model->scale = PyFloat_AsDouble( PyDict_GetItemString(self->params, "scale") );
+    self->model->background = PyFloat_AsDouble( PyDict_GetItemString(self->params, "background") );
+    self->model->shell_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "shell_sld") );
+    // Read in dispersion parameters
+    PyObject* disp_dict;
+    DispersionVisitor* visitor = new DispersionVisitor();
+    disp_dict = PyDict_GetItemString(self->dispersion, "core_radius");
+    self->model->core_radius.dispersion->accept_as_destination(visitor, self->model->core_radius.dispersion, disp_dict);
+
+	
+	// Get input and determine whether we have to supply a 1D or 2D return value.
+	if ( !PyArg_ParseTuple(args,"O",&pars) ) {
+	    PyErr_SetString(CMultiShellModelError, 
+	    	"CMultiShellModel.run expects a q value.");
+		return NULL;
+	}
+	  
+	// Check params
+	if( PyList_Check(pars)==1) {
+		
+		// Length of list should be 2 for I(q,phi)
+	    npars = PyList_GET_SIZE(pars); 
+	    if(npars!=2) {
+	    	PyErr_SetString(CMultiShellModelError, 
+	    		"CMultiShellModel.run expects a double or a list of dimension 2.");
+	    	return NULL;
+	    }
+	    // We have a vector q, get the q and phi values at which
+	    // to evaluate I(q,phi)
+	    q_value = CMultiShellModel_readDouble(PyList_GET_ITEM(pars,0));
+	    phi_value = CMultiShellModel_readDouble(PyList_GET_ITEM(pars,1));
+	    // Skip zero
+	    if (q_value==0) {
+	    	return Py_BuildValue("d",0.0);
+	    }
+		return Py_BuildValue("d",(*(self->model)).evaluate_rphi(q_value,phi_value));
+
+	} else {
+
+		// We have a scalar q, we will evaluate I(q)
+		q_value = CMultiShellModel_readDouble(pars);		
+		
+		return Py_BuildValue("d",(*(self->model))(q_value));
+	}	
+}
+
+/**
+ * Function to call to evaluate model in cartesian coordinates
+ * @param args: input q or [qx, qy]]
+ * @return: function value
+ */
+static PyObject * runXY(CMultiShellModel *self, PyObject *args) {
+	double qx_value, qy_value;
+	PyObject* pars;
+	int npars;
+	
+	// Get parameters
+	
+	    // Reader parameter dictionary
+    self->model->core_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "core_sld") );
+    self->model->core_radius = PyFloat_AsDouble( PyDict_GetItemString(self->params, "core_radius") );
+    self->model->n_pairs = PyFloat_AsDouble( PyDict_GetItemString(self->params, "n_pairs") );
+    self->model->w_thickness = PyFloat_AsDouble( PyDict_GetItemString(self->params, "w_thickness") );
+    self->model->s_thickness = PyFloat_AsDouble( PyDict_GetItemString(self->params, "s_thickness") );
+    self->model->scale = PyFloat_AsDouble( PyDict_GetItemString(self->params, "scale") );
+    self->model->background = PyFloat_AsDouble( PyDict_GetItemString(self->params, "background") );
+    self->model->shell_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "shell_sld") );
+    // Read in dispersion parameters
+    PyObject* disp_dict;
+    DispersionVisitor* visitor = new DispersionVisitor();
+    disp_dict = PyDict_GetItemString(self->dispersion, "core_radius");
+    self->model->core_radius.dispersion->accept_as_destination(visitor, self->model->core_radius.dispersion, disp_dict);
+
+	
+	// Get input and determine whether we have to supply a 1D or 2D return value.
+	if ( !PyArg_ParseTuple(args,"O",&pars) ) {
+	    PyErr_SetString(CMultiShellModelError, 
+	    	"CMultiShellModel.run expects a q value.");
+		return NULL;
+	}
+	  
+	// Check params
+	if( PyList_Check(pars)==1) {
+		
+		// Length of list should be 2 for I(qx, qy))
+	    npars = PyList_GET_SIZE(pars); 
+	    if(npars!=2) {
+	    	PyErr_SetString(CMultiShellModelError, 
+	    		"CMultiShellModel.run expects a double or a list of dimension 2.");
+	    	return NULL;
+	    }
+	    // We have a vector q, get the qx and qy values at which
+	    // to evaluate I(qx,qy)
+	    qx_value = CMultiShellModel_readDouble(PyList_GET_ITEM(pars,0));
+	    qy_value = CMultiShellModel_readDouble(PyList_GET_ITEM(pars,1));
+	    return Py_BuildValue("d",(*(self->model))(qx_value,qy_value));
+
+	} else {
+
+		// We have a scalar q, we will evaluate I(q)
+		qx_value = CMultiShellModel_readDouble(pars);		
+		
+		return Py_BuildValue("d",(*(self->model))(qx_value));
+	}	
+}
+
+static PyObject * reset(CMultiShellModel *self, PyObject *args) {
+    
+
+    return Py_BuildValue("d",0.0);
+}
+
+static PyObject * set_dispersion(CMultiShellModel *self, PyObject *args) {
+	PyObject * disp;
+	const char * par_name;
+
+	if ( !PyArg_ParseTuple(args,"sO", &par_name, &disp) ) {
+	    PyErr_SetString(CMultiShellModelError,
+	    	"CMultiShellModel.set_dispersion expects a DispersionModel object.");
+		return NULL;
+	}
+	void *temp = PyCObject_AsVoidPtr(disp);
+	DispersionModel * dispersion = static_cast<DispersionModel *>(temp);
+
+
+	// Ugliness necessary to go from python to C
+	    // TODO: refactor this
+    if (!strcmp(par_name, "core_radius")) {
+        self->model->core_radius.dispersion = dispersion;
+    } else {
+	    PyErr_SetString(CMultiShellModelError,
+	    	"CMultiShellModel.set_dispersion expects a valid parameter name.");
+		return NULL;
+	}
+
+	DispersionVisitor* visitor = new DispersionVisitor();
+	PyObject * disp_dict = PyDict_New();
+	dispersion->accept_as_source(visitor, dispersion, disp_dict);
+	PyDict_SetItemString(self->dispersion, par_name, disp_dict);
+    return Py_BuildValue("i",1);
+}
+
+
+static PyMethodDef CMultiShellModel_methods[] = {
+    {"run",      (PyCFunction)run     , METH_VARARGS,
+      "Evaluate the model at a given Q or Q, phi"},
+    {"runXY",      (PyCFunction)runXY     , METH_VARARGS,
+      "Evaluate the model at a given Q or Qx, Qy"},
+    {"reset",    (PyCFunction)reset   , METH_VARARGS,
+      "Reset pair correlation"},
+    {"set_dispersion",      (PyCFunction)set_dispersion     , METH_VARARGS,
+      "Set the dispersion model for a given parameter"},
+   {NULL}
+};
+
+static PyTypeObject CMultiShellModelType = {
+    PyObject_HEAD_INIT(NULL)
+    0,                         /*ob_size*/
+    "CMultiShellModel",             /*tp_name*/
+    sizeof(CMultiShellModel),             /*tp_basicsize*/
+    0,                         /*tp_itemsize*/
+    (destructor)CMultiShellModel_dealloc, /*tp_dealloc*/
+    0,                         /*tp_print*/
+    0,                         /*tp_getattr*/
+    0,                         /*tp_setattr*/
+    0,                         /*tp_compare*/
+    0,                         /*tp_repr*/
+    0,                         /*tp_as_number*/
+    0,                         /*tp_as_sequence*/
+    0,                         /*tp_as_mapping*/
+    0,                         /*tp_hash */
+    0,                         /*tp_call*/
+    0,                         /*tp_str*/
+    0,                         /*tp_getattro*/
+    0,                         /*tp_setattro*/
+    0,                         /*tp_as_buffer*/
+    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
+    "CMultiShellModel objects",           /* tp_doc */
+    0,		               /* tp_traverse */
+    0,		               /* tp_clear */
+    0,		               /* tp_richcompare */
+    0,		               /* tp_weaklistoffset */
+    0,		               /* tp_iter */
+    0,		               /* tp_iternext */
+    CMultiShellModel_methods,             /* tp_methods */
+    CMultiShellModel_members,             /* tp_members */
+    0,                         /* tp_getset */
+    0,                         /* tp_base */
+    0,                         /* tp_dict */
+    0,                         /* tp_descr_get */
+    0,                         /* tp_descr_set */
+    0,                         /* tp_dictoffset */
+    (initproc)CMultiShellModel_init,      /* tp_init */
+    0,                         /* tp_alloc */
+    CMultiShellModel_new,                 /* tp_new */
+};
+
+
+static PyMethodDef module_methods[] = {
+    {NULL} 
+};
+
+/**
+ * Function used to add the model class to a module
+ * @param module: module to add the class to
+ */ 
+void addCMultiShellModel(PyObject *module) {
+	PyObject *d;
+	
+    if (PyType_Ready(&CMultiShellModelType) < 0)
+        return;
+
+    Py_INCREF(&CMultiShellModelType);
+    PyModule_AddObject(module, "CMultiShellModel", (PyObject *)&CMultiShellModelType);
+    
+    d = PyModule_GetDict(module);
+    CMultiShellModelError = PyErr_NewException("CMultiShellModel.error", NULL, NULL);
+    PyDict_SetItemString(d, "CMultiShellModelError", CMultiShellModelError);
+}
+
Index: sansmodels/src/sans/models/c_models/CVesicleModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CVesicleModel.cpp	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
+++ sansmodels/src/sans/models/c_models/CVesicleModel.cpp	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -0,0 +1,369 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/** CVesicleModel
+ *
+ * C extension 
+ *
+ * WARNING: THIS FILE WAS GENERATED BY WRAPPERGENERATOR.PY
+ *          DO NOT MODIFY THIS FILE, MODIFY vesicle.h
+ *          AND RE-RUN THE GENERATOR SCRIPT
+ *
+ */
+ 
+extern "C" {
+#include <Python.h>
+#include "structmember.h"
+#include <stdio.h>
+#include <stdlib.h>
+#include <math.h>
+#include <time.h>
+#include "vesicle.h"
+}
+
+#include "models.hh"
+#include "dispersion_visitor.hh"
+
+/// Error object for raised exceptions
+static PyObject * CVesicleModelError = NULL;
+
+
+// Class definition
+typedef struct {
+    PyObject_HEAD
+    /// Parameters
+    PyObject * params;
+    /// Dispersion parameters
+    PyObject * dispersion;
+    /// Underlying model object
+    VesicleModel * model;
+    /// Log for unit testing
+    PyObject * log;
+} CVesicleModel;
+
+
+static void
+CVesicleModel_dealloc(CVesicleModel* self)
+{
+    self->ob_type->tp_free((PyObject*)self);
+    
+
+}
+
+static PyObject *
+CVesicleModel_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
+{
+    CVesicleModel *self;
+    
+    self = (CVesicleModel *)type->tp_alloc(type, 0);
+   
+    return (PyObject *)self;
+}
+
+static int
+CVesicleModel_init(CVesicleModel *self, PyObject *args, PyObject *kwds)
+{
+    if (self != NULL) {
+    	
+    	// Create parameters
+        self->params = PyDict_New();
+        self->dispersion = PyDict_New();
+        self->model = new VesicleModel();
+        
+        // Initialize parameter dictionary
+        PyDict_SetItemString(self->params,"core_sld",Py_BuildValue("d",0.000006));
+        PyDict_SetItemString(self->params,"core_radius",Py_BuildValue("d",100.000000));
+        PyDict_SetItemString(self->params,"thickness",Py_BuildValue("d",30.000000));
+        PyDict_SetItemString(self->params,"scale",Py_BuildValue("d",1.000000));
+        PyDict_SetItemString(self->params,"background",Py_BuildValue("d",0.000000));
+        PyDict_SetItemString(self->params,"shell_sld",Py_BuildValue("d",0.000000));
+        // Initialize dispersion / averaging parameter dict
+        DispersionVisitor* visitor = new DispersionVisitor();
+        PyObject * disp_dict;
+        disp_dict = PyDict_New();
+        self->model->core_radius.dispersion->accept_as_source(visitor, self->model->core_radius.dispersion, disp_dict);
+        PyDict_SetItemString(self->dispersion, "core_radius", disp_dict);
+
+
+         
+        // Create empty log
+        self->log = PyDict_New();
+        
+        
+
+    }
+    return 0;
+}
+
+static PyMemberDef CVesicleModel_members[] = {
+    {"params", T_OBJECT, offsetof(CVesicleModel, params), 0,
+     "Parameters"},
+	{"dispersion", T_OBJECT, offsetof(CVesicleModel, dispersion), 0,
+	  "Dispersion parameters"},     
+    {"log", T_OBJECT, offsetof(CVesicleModel, log), 0,
+     "Log"},
+    {NULL}  /* Sentinel */
+};
+
+/** Read double from PyObject
+    @param p PyObject
+    @return double
+*/
+double CVesicleModel_readDouble(PyObject *p) {
+    if (PyFloat_Check(p)==1) {
+        return (double)(((PyFloatObject *)(p))->ob_fval);
+    } else if (PyInt_Check(p)==1) {
+        return (double)(((PyIntObject *)(p))->ob_ival);
+    } else if (PyLong_Check(p)==1) {
+        return (double)PyLong_AsLong(p);
+    } else {
+        return 0.0;
+    }
+}
+
+
+/**
+ * Function to call to evaluate model
+ * @param args: input q or [q,phi]
+ * @return: function value
+ */
+static PyObject * run(CVesicleModel *self, PyObject *args) {
+	double q_value, phi_value;
+	PyObject* pars;
+	int npars;
+	
+	// Get parameters
+	
+	    // Reader parameter dictionary
+    self->model->core_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "core_sld") );
+    self->model->core_radius = PyFloat_AsDouble( PyDict_GetItemString(self->params, "core_radius") );
+    self->model->thickness = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thickness") );
+    self->model->scale = PyFloat_AsDouble( PyDict_GetItemString(self->params, "scale") );
+    self->model->background = PyFloat_AsDouble( PyDict_GetItemString(self->params, "background") );
+    self->model->shell_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "shell_sld") );
+    // Read in dispersion parameters
+    PyObject* disp_dict;
+    DispersionVisitor* visitor = new DispersionVisitor();
+    disp_dict = PyDict_GetItemString(self->dispersion, "core_radius");
+    self->model->core_radius.dispersion->accept_as_destination(visitor, self->model->core_radius.dispersion, disp_dict);
+
+	
+	// Get input and determine whether we have to supply a 1D or 2D return value.
+	if ( !PyArg_ParseTuple(args,"O",&pars) ) {
+	    PyErr_SetString(CVesicleModelError, 
+	    	"CVesicleModel.run expects a q value.");
+		return NULL;
+	}
+	  
+	// Check params
+	if( PyList_Check(pars)==1) {
+		
+		// Length of list should be 2 for I(q,phi)
+	    npars = PyList_GET_SIZE(pars); 
+	    if(npars!=2) {
+	    	PyErr_SetString(CVesicleModelError, 
+	    		"CVesicleModel.run expects a double or a list of dimension 2.");
+	    	return NULL;
+	    }
+	    // We have a vector q, get the q and phi values at which
+	    // to evaluate I(q,phi)
+	    q_value = CVesicleModel_readDouble(PyList_GET_ITEM(pars,0));
+	    phi_value = CVesicleModel_readDouble(PyList_GET_ITEM(pars,1));
+	    // Skip zero
+	    if (q_value==0) {
+	    	return Py_BuildValue("d",0.0);
+	    }
+		return Py_BuildValue("d",(*(self->model)).evaluate_rphi(q_value,phi_value));
+
+	} else {
+
+		// We have a scalar q, we will evaluate I(q)
+		q_value = CVesicleModel_readDouble(pars);		
+		
+		return Py_BuildValue("d",(*(self->model))(q_value));
+	}	
+}
+
+/**
+ * Function to call to evaluate model in cartesian coordinates
+ * @param args: input q or [qx, qy]]
+ * @return: function value
+ */
+static PyObject * runXY(CVesicleModel *self, PyObject *args) {
+	double qx_value, qy_value;
+	PyObject* pars;
+	int npars;
+	
+	// Get parameters
+	
+	    // Reader parameter dictionary
+    self->model->core_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "core_sld") );
+    self->model->core_radius = PyFloat_AsDouble( PyDict_GetItemString(self->params, "core_radius") );
+    self->model->thickness = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thickness") );
+    self->model->scale = PyFloat_AsDouble( PyDict_GetItemString(self->params, "scale") );
+    self->model->background = PyFloat_AsDouble( PyDict_GetItemString(self->params, "background") );
+    self->model->shell_sld = PyFloat_AsDouble( PyDict_GetItemString(self->params, "shell_sld") );
+    // Read in dispersion parameters
+    PyObject* disp_dict;
+    DispersionVisitor* visitor = new DispersionVisitor();
+    disp_dict = PyDict_GetItemString(self->dispersion, "core_radius");
+    self->model->core_radius.dispersion->accept_as_destination(visitor, self->model->core_radius.dispersion, disp_dict);
+
+	
+	// Get input and determine whether we have to supply a 1D or 2D return value.
+	if ( !PyArg_ParseTuple(args,"O",&pars) ) {
+	    PyErr_SetString(CVesicleModelError, 
+	    	"CVesicleModel.run expects a q value.");
+		return NULL;
+	}
+	  
+	// Check params
+	if( PyList_Check(pars)==1) {
+		
+		// Length of list should be 2 for I(qx, qy))
+	    npars = PyList_GET_SIZE(pars); 
+	    if(npars!=2) {
+	    	PyErr_SetString(CVesicleModelError, 
+	    		"CVesicleModel.run expects a double or a list of dimension 2.");
+	    	return NULL;
+	    }
+	    // We have a vector q, get the qx and qy values at which
+	    // to evaluate I(qx,qy)
+	    qx_value = CVesicleModel_readDouble(PyList_GET_ITEM(pars,0));
+	    qy_value = CVesicleModel_readDouble(PyList_GET_ITEM(pars,1));
+	    return Py_BuildValue("d",(*(self->model))(qx_value,qy_value));
+
+	} else {
+
+		// We have a scalar q, we will evaluate I(q)
+		qx_value = CVesicleModel_readDouble(pars);		
+		
+		return Py_BuildValue("d",(*(self->model))(qx_value));
+	}	
+}
+
+static PyObject * reset(CVesicleModel *self, PyObject *args) {
+    
+
+    return Py_BuildValue("d",0.0);
+}
+
+static PyObject * set_dispersion(CVesicleModel *self, PyObject *args) {
+	PyObject * disp;
+	const char * par_name;
+
+	if ( !PyArg_ParseTuple(args,"sO", &par_name, &disp) ) {
+	    PyErr_SetString(CVesicleModelError,
+	    	"CVesicleModel.set_dispersion expects a DispersionModel object.");
+		return NULL;
+	}
+	void *temp = PyCObject_AsVoidPtr(disp);
+	DispersionModel * dispersion = static_cast<DispersionModel *>(temp);
+
+
+	// Ugliness necessary to go from python to C
+	    // TODO: refactor this
+    if (!strcmp(par_name, "core_radius")) {
+        self->model->core_radius.dispersion = dispersion;
+    } else {
+	    PyErr_SetString(CVesicleModelError,
+	    	"CVesicleModel.set_dispersion expects a valid parameter name.");
+		return NULL;
+	}
+
+	DispersionVisitor* visitor = new DispersionVisitor();
+	PyObject * disp_dict = PyDict_New();
+	dispersion->accept_as_source(visitor, dispersion, disp_dict);
+	PyDict_SetItemString(self->dispersion, par_name, disp_dict);
+    return Py_BuildValue("i",1);
+}
+
+
+static PyMethodDef CVesicleModel_methods[] = {
+    {"run",      (PyCFunction)run     , METH_VARARGS,
+      "Evaluate the model at a given Q or Q, phi"},
+    {"runXY",      (PyCFunction)runXY     , METH_VARARGS,
+      "Evaluate the model at a given Q or Qx, Qy"},
+    {"reset",    (PyCFunction)reset   , METH_VARARGS,
+      "Reset pair correlation"},
+    {"set_dispersion",      (PyCFunction)set_dispersion     , METH_VARARGS,
+      "Set the dispersion model for a given parameter"},
+   {NULL}
+};
+
+static PyTypeObject CVesicleModelType = {
+    PyObject_HEAD_INIT(NULL)
+    0,                         /*ob_size*/
+    "CVesicleModel",             /*tp_name*/
+    sizeof(CVesicleModel),             /*tp_basicsize*/
+    0,                         /*tp_itemsize*/
+    (destructor)CVesicleModel_dealloc, /*tp_dealloc*/
+    0,                         /*tp_print*/
+    0,                         /*tp_getattr*/
+    0,                         /*tp_setattr*/
+    0,                         /*tp_compare*/
+    0,                         /*tp_repr*/
+    0,                         /*tp_as_number*/
+    0,                         /*tp_as_sequence*/
+    0,                         /*tp_as_mapping*/
+    0,                         /*tp_hash */
+    0,                         /*tp_call*/
+    0,                         /*tp_str*/
+    0,                         /*tp_getattro*/
+    0,                         /*tp_setattro*/
+    0,                         /*tp_as_buffer*/
+    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
+    "CVesicleModel objects",           /* tp_doc */
+    0,		               /* tp_traverse */
+    0,		               /* tp_clear */
+    0,		               /* tp_richcompare */
+    0,		               /* tp_weaklistoffset */
+    0,		               /* tp_iter */
+    0,		               /* tp_iternext */
+    CVesicleModel_methods,             /* tp_methods */
+    CVesicleModel_members,             /* tp_members */
+    0,                         /* tp_getset */
+    0,                         /* tp_base */
+    0,                         /* tp_dict */
+    0,                         /* tp_descr_get */
+    0,                         /* tp_descr_set */
+    0,                         /* tp_dictoffset */
+    (initproc)CVesicleModel_init,      /* tp_init */
+    0,                         /* tp_alloc */
+    CVesicleModel_new,                 /* tp_new */
+};
+
+
+static PyMethodDef module_methods[] = {
+    {NULL} 
+};
+
+/**
+ * Function used to add the model class to a module
+ * @param module: module to add the class to
+ */ 
+void addCVesicleModel(PyObject *module) {
+	PyObject *d;
+	
+    if (PyType_Ready(&CVesicleModelType) < 0)
+        return;
+
+    Py_INCREF(&CVesicleModelType);
+    PyModule_AddObject(module, "CVesicleModel", (PyObject *)&CVesicleModelType);
+    
+    d = PyModule_GetDict(module);
+    CVesicleModelError = PyErr_NewException("CVesicleModel.error", NULL, NULL);
+    PyDict_SetItemString(d, "CVesicleModelError", CVesicleModelError);
+}
+
Index: sansmodels/src/sans/models/c_models/binaryHS.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/binaryHS.cpp	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
+++ sansmodels/src/sans/models/c_models/binaryHS.cpp	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -0,0 +1,115 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ *
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libSphere.h"
+}
+
+BinaryHSModel :: BinaryHSModel() {
+	
+	l_radius     = Parameter(160.0, true);
+	l_radius.set_min(0.0);
+	s_radius    = Parameter(25.0, true);
+	s_radius.set_min(0.0);
+	vol_frac_ls  = Parameter(0.2);
+	vol_frac_ss  = Parameter(0.1);
+	ls_sld      = Parameter(3.5e-6);
+	ss_sld     = Parameter(5e-7);
+	solvent_sld   = Parameter(6.36e-6);
+	background = Parameter(0.0);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double BinaryHSModel :: operator()(double q) {
+	double dp[8];
+
+	// Fill parameter array for IGOR library
+	// Add the background after averaging
+	dp[0] = l_radius();
+	dp[1] = s_radius();
+	dp[2] = vol_frac_ls();
+	dp[3] = vol_frac_ss();
+	dp[4] = ls_sld();
+	dp[5] = ss_sld();
+	dp[6] = solvent_sld();
+	dp[7] = background();
+	
+
+	// Get the dispersion points for the large radius
+	vector<WeightPoint> weights_l_radius;
+	l_radius.get_weights(weights_l_radius);
+
+	// Get the dispersion points for the small radius
+	vector<WeightPoint> weights_s_radius;
+	s_radius.get_weights(weights_s_radius);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Loop over larger radius weight points
+	for(int i=0; i< (int)weights_l_radius.size(); i++) {
+		dp[0] = weights_l_radius[i].value;
+		
+		// Loop over small radius weight points
+		for(int j=0; j< (int)weights_s_radius.size(); j++) {
+			dp[1] = weights_s_radius[j].value;
+
+
+			sum += weights_l_radius[i].weight *weights_s_radius[j].weight * BinaryHS(dp, q);
+			norm += weights_l_radius[i].weight *weights_s_radius[j].weight;
+		}
+	}
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double BinaryHSModel :: operator()(double qx, double qy) {
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the vesicle
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double BinaryHSModel :: evaluate_rphi(double q, double phi) {
+	return (*this).operator()(q);
+}
Index: sansmodels/src/sans/models/c_models/c_models.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/c_models.cpp	(revision 27fea3fd73c362e927fb15e5806e0a587260c5f3)
+++ sansmodels/src/sans/models/c_models/c_models.cpp	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -32,4 +32,7 @@
 void addCLamellarFFHGModel(PyObject *module);
 void addCHollowCylinderModel(PyObject *module);
+void addCMultiShellModel(PyObject *module);
+void addCVesicleModel(PyObject *module);
+void addCBinaryHSModel(PyObject *module);
 
 
@@ -183,7 +186,10 @@
 	addCLamellarFFHGModel(m);
 	addCHollowCylinderModel(m);
+	addCMultiShellModel(m);
+	addCBinaryHSModel(m);
 	addDisperser(m);
 	addCGaussian(m);
 	addCLorentzian(m);
+	addCVesicleModel(m);
 
 
Index: sansmodels/src/sans/models/c_models/models.hh
===================================================================
--- sansmodels/src/sans/models/c_models/models.hh	(revision 27fea3fd73c362e927fb15e5806e0a587260c5f3)
+++ sansmodels/src/sans/models/c_models/models.hh	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -483,3 +483,65 @@
 	double evaluate_rphi(double q, double phi);
 };
+
+class MultiShellModel{
+public:
+	// Model parameters
+	Parameter scale;
+	Parameter core_radius;
+	Parameter s_thickness;
+	Parameter w_thickness;
+	Parameter core_sld;
+	Parameter shell_sld;
+	Parameter n_pairs;
+	Parameter background;
+	
+	//Constructor
+	MultiShellModel();
+	
+	//Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx , double qy);
+	double evaluate_rphi(double q, double phi);
+};
+
+class VesicleModel{
+public:
+	// Model parameters
+	Parameter scale;
+	Parameter core_radius;
+	Parameter thickness;
+	Parameter core_sld;
+	Parameter shell_sld;
+	Parameter background;
+	
+	//Constructor
+	VesicleModel();
+	
+	//Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx , double qy);
+	double evaluate_rphi(double q, double phi);
+};
+
+class BinaryHSModel{
+public:
+	// Model parameters
+	Parameter l_radius;
+	Parameter s_radius;
+	Parameter vol_frac_ls;
+	Parameter vol_frac_ss;
+	Parameter ls_sld;
+	Parameter ss_sld;
+	Parameter solvent_sld;
+	Parameter background;
+	
+	//Constructor
+	BinaryHSModel();
+	
+	//Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx , double qy);
+	double evaluate_rphi(double q, double phi);
+};
+
 #endif
Index: sansmodels/src/sans/models/c_models/multishell.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/multishell.cpp	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
+++ sansmodels/src/sans/models/c_models/multishell.cpp	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -0,0 +1,103 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ *
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libSphere.h"
+}
+
+MultiShellModel :: MultiShellModel() {
+	scale      = Parameter(1.0);
+	core_radius     = Parameter(60.0, true);
+	core_radius.set_min(0.0);
+	s_thickness  = Parameter(10.0);
+	w_thickness   = Parameter(10.0);
+	core_sld   = Parameter(6.4e-6);
+	shell_sld   = Parameter(4.0e-7);
+	n_pairs   = Parameter(2);
+	background = Parameter(0.0);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double MultiShellModel :: operator()(double q) {
+	double dp[8];
+
+	// Fill parameter array for IGOR library
+	// Add the background after averaging
+	dp[0] = scale();
+	dp[1] = core_radius();
+	dp[2] = s_thickness();
+	dp[3] = w_thickness();
+	dp[4] = core_sld();
+	dp[5] = shell_sld();
+	dp[6] = n_pairs();
+	dp[7] = background();
+
+	// Get the dispersion points for the core radius
+	vector<WeightPoint> weights_core_radius;
+	core_radius.get_weights(weights_core_radius);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Loop over radius weight points
+	for(int i=0; i< (int)weights_core_radius.size(); i++) {
+		dp[1] = weights_core_radius[i].value;
+
+		sum += weights_core_radius[i].weight
+			* MultiShell(dp, q);
+		norm += weights_core_radius[i].weight;
+	}
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double MultiShellModel :: operator()(double qx, double qy) {
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the multishell
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double MultiShellModel :: evaluate_rphi(double q, double phi) {
+	return (*this).operator()(q);
+}
Index: sansmodels/src/sans/models/c_models/vesicle.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/vesicle.cpp	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
+++ sansmodels/src/sans/models/c_models/vesicle.cpp	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -0,0 +1,100 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ *
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libSphere.h"
+}
+
+VesicleModel :: VesicleModel() {
+	scale      = Parameter(1.0);
+	core_radius     = Parameter(100.0, true);
+	core_radius.set_min(0.0);
+	thickness  = Parameter(30.0);
+	core_sld   = Parameter(6.36e-6);
+	shell_sld   = Parameter(5.0e-7);
+	background = Parameter(0.0);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double VesicleModel :: operator()(double q) {
+	double dp[6];
+
+	// Fill parameter array for IGOR library
+	// Add the background after averaging
+	dp[0] = scale();
+	dp[1] = core_radius();
+	dp[2] = thickness();
+	dp[3] = core_sld();
+	dp[4] = shell_sld();
+	dp[5] = background();
+	
+
+	// Get the dispersion points for the core radius
+	vector<WeightPoint> weights_core_radius;
+	core_radius.get_weights(weights_core_radius);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Loop over radius weight points
+	for(int i=0; i< (int)weights_core_radius.size(); i++) {
+		dp[1] = weights_core_radius[i].value;
+
+		sum += weights_core_radius[i].weight
+			* VesicleForm(dp, q);
+		norm += weights_core_radius[i].weight;
+	}
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double VesicleModel :: operator()(double qx, double qy) {
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the vesicle
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double VesicleModel :: evaluate_rphi(double q, double phi) {
+	return (*this).operator()(q);
+}
Index: sansmodels/src/setup.py
===================================================================
--- sansmodels/src/setup.py	(revision 27fea3fd73c362e927fb15e5806e0a587260c5f3)
+++ sansmodels/src/setup.py	(revision 3d25331f0e8a822fc6c59f15883b1cd21463b567)
@@ -11,5 +11,4 @@
 """
 import sys
-
 
 
@@ -185,4 +184,16 @@
         "sans/models/c_models/prolate.cpp",                
         srcdir+"/prolate.c",
+        #srcdir+"/CMultishellModel.c",
+        "sans/models/c_models/CMultishellModel.cpp",
+        "sans/models/c_models/multishell.cpp",                
+        srcdir+"/multishell.c",
+        #srcdir+"/CVesicleModel.c",
+        "sans/models/c_models/CVesicleModel.cpp",
+        "sans/models/c_models/vesicle.cpp",                
+        srcdir+"/vesicle.c",
+        #srcdir+"/CBinaryHSModel.c",
+        "sans/models/c_models/CBinaryHSModel.cpp",
+        "sans/models/c_models/binaryHS.cpp",                
+        srcdir+"/binaryHS.c",
         srcdir+"/disperser.c",
         igordir+"/libCylinder.c",
